{% extends "base.html" %}

{% block links %}
{{ super() }}
{% endblock %}

{% block title %}
Placement des soutenances
{% endblock %}




{% block header %}
{% include "sub_templates/header.html" %}
{% endblock %}



{% block main %}

<div id="modal" class="fixed z-10 inset-0 overflow-y-auto hidden">
  <div class="flex items-center justify-center min-h-screen pt-4 px-4 pb-20 text-center sm:block sm:p-0">

    <!-- Overlay -->
    <div class="fixed inset-0 transition-opacity" aria-hidden="true">
      <div class="absolute inset-0 bg-gray-500 opacity-75"></div>
    </div>

    <!-- Modal -->
    <div class="inline-block align-bottom bg-white rounded-lg text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:align-middle sm:max-w-lg sm:w-full">
      <div class="bg-white px-4 pt-5 pb-4 sm:p-6 sm:pb-4">
        <div class="sm:flex sm:items-start mx-auto">
          <div class="mx-auto flex-shrink-0 flex items-center justify-center h-12 w-12 rounded-full bg-green-100 sm:mx-0 sm:h-10 sm:w-10">
            <!-- Heroicon name: outline/check -->
            <svg class="h-6 w-6 text-green-600" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor" aria-hidden="true">
              <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M5 13l4 4L19 7"></path>
            </svg>
          </div>
          <div class="mt-3 text-center sm:mt-0 sm:ml-4 sm:text-left">
            <h3 class="text-lg leading-6 font-medium text-gray-900" id="modal-title">
              Ajouter une soutenance
            </h3>
            <div class="mt-2">
              <div>
                <label class="font-medium mb-2 text-gray-900 text-sm">Salle</label>
                <select required id="room-input" class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2"  required>
                  {% for room in rooms %}
                  <option id="{{room.id}}" value="{{room.name}}">{{room.name}}</option>
                  {% endfor %}
                </select>
              </div>
              
              <div>
                <label class="font-medium mb-2 text-gray-900 text-sm">Soutenance</label>
                <select required id="soutenance-input" class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2"  required>
                  {% for soutenance in soutenances %}
                  <option id="{{soutenance.id}}" value="{{soutenance.mission_request.user.first_name}} {{soutenance.mission_request.user.last_name}}">{{soutenance.mission_request.user.first_name}} {{soutenance.mission_request.user.last_name}}</option>
                  {% endfor %}
                </select>
              </div>
              
              <div>
                <label class="font-medium mb-2 text-gray-900 text-sm">Heure de début</label>
                <input type="time" min="08:00" max="17:30" id="start-input" required class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2" required>
              </div>
              
              <div>
                <label class="font-medium mb-2 text-gray-900 text-sm">Durée (en min)</label>
                <input type="number" min="0" max="120" required value="60" id="duration-input" class="shadow bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg hover:border-blue-500 focus:border-blue-500 block w-full px-2.5 py-2"  required>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="bg-gray-50 px-4 py-3 sm:px-6 sm:flex sm:flex-row-reverse">
        <button type="button" id="validate-button" class="w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-green-600 text-base font-medium text-white hover:bg-green-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-green-500 sm:ml-3 sm:w-auto sm:text-sm">
          Sauvegarder
        </button>
        <button type="button" id="cancel-button" class="mt-3 w-full inline-flex justify-center rounded-md border border-gray-300 shadow-sm px-4 py-2 bg-white text-base font-medium text-gray-700 hover:bg-gray-50 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-green-500 sm:mt-0 sm:ml-3 sm:w-auto sm:text-sm">
          Annuler
        </button>
      </div>
    </div>
  </div>
</div>

<!-- <button id="submit-btn" class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded mt-4">Ajouter l'événement</button> -->
  

<div id='calendar'></div>

{% endblock %}



{% block footer %}
{% include "sub_templates/footer.html" %}
{% endblock footer%}


{% block script %}
{{ super() }}
<script src='https://cdn.jsdelivr.net/npm/@fullcalendar/core@6.1.5/index.global.min.js'></script>
<script src='https://cdn.jsdelivr.net/npm/@fullcalendar/daygrid@6.1.5/index.global.min.js'></script>
<script src='https://cdn.jsdelivr.net/npm/@fullcalendar/interaction@6.1.5/index.global.min.js'></script>
<script src='https://cdn.jsdelivr.net/npm/fullcalendar@6.1.5/index.global.min.js'></script>
<script>
renderCalendar() 


function renderCalendar(){
  document.addEventListener('DOMContentLoaded', function() {
    let calendarEl = document.getElementById('calendar');

    const calendar = new FullCalendar.Calendar(calendarEl, {
        // parametres du calendar
        initialView: 'timeGridWeek', //dayGridWeek
        headerToolbar: {
          left: 'prev,next',
          center: 'title',
          right: 'timeGridWeek,listDay',
        },
        buttonText:{
          week:'Semaine',
          list:'Liste'
        },
        locale:'fr',
        selectable:true,
        weekNumbers:true,
        weekends:false,
        nowIndicator:true,
        slotMinTime: '08:00:00',
        slotMaxTime: '18:00:00',
        select: function(start, end, allDays){
          openModal()

          document.getElementById("cancel-button").addEventListener("click", function(){
            closeModal();
          });

          // enregistrement de l'event
          document.getElementById("validate-button").addEventListener("click", function(){

            calendar.batchRendering(function() {
              room = document.getElementById("room-input").value;
              soutenance = document.getElementById("soutenance-input").value;
              start_hour = document.getElementById("start-input").value; 
              time = document.getElementById("duration-input").value;
              day = start.startStr;

              let duration_ms = parseInt(time) * 60 * 1000;

              let start_date = new Date(day);

              // Récupérer l'heure et les minutes de la date contenue dans la variable start_hour
              let [hours, minutes] = start_hour.split(':');

              // Modifier l'heure de la date avec les heures et minutes récupérés précédemment
              start_date.setHours(hours);
              start_date.setHours(start_date.getHours() + 2);
              start_date.setMinutes(minutes);

              let end_time = new Date(start_date.getTime() + duration_ms);

              let new_hour = ("0" + end_time.getHours()).slice(-2) + ":" + ("0" + end_time.getMinutes()).slice(-2);

              let [hour, minute] = new_hour.split(':');

              let end_date = new Date(day);
              end_date.setHours(hour);
              end_date.setMinutes(minute);

              let formatted_start_date = start_date.toISOString().slice(0, 10) +
               ' ' + start_date.toISOString().slice(11, 19); // date de début de l'event
              let formatted_end_date = end_date.toISOString().slice(0, 10) +
              ' ' + end_date.toISOString().slice(11, 19); // date de fin de l'event

              newEvent = {
                "title": room + " " + soutenance,
                "start": formatted_start_date,
                "end": formatted_end_date,
              };
              calendar.addEvent(newEvent);
              closeModal();
            })

          });

        }
      })
    calendar.render();
  });
}

function openModal() {
    document.getElementById("modal").classList.remove('hidden');
  }

function closeModal(){
  document.getElementById("room-input").value = document.getElementById("room-input").options[0];
  document.getElementById("soutenance-input").value = document.getElementById("soutenance-input").options[0];
  document.getElementById("start-input").value = "";
  document.getElementById("duration-input").value = "60";
  document.getElementById("modal").classList.add('hidden');
}

</script>
{% endblock %}